(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/forms'), require('@ionic/angular'), require('@angular/core'), require('@ngx-formly/core')) :
    typeof define === 'function' && define.amd ? define('@ngx-formly/ionic/form-field', ['exports', '@angular/common', '@angular/forms', '@ionic/angular', '@angular/core', '@ngx-formly/core'], factory) :
    (factory((global['ngx-formly'] = global['ngx-formly'] || {}, global['ngx-formly'].ionic = global['ngx-formly'].ionic || {}, global['ngx-formly'].ionic['form-field'] = {}),global.ng.common,global.ng.forms,global.angular,global.ng.core,global.core$1));
}(this, (function (exports,common,forms,angular,core,core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormlyWrapperFormField = /** @class */ (function (_super) {
        __extends(FormlyWrapperFormField, _super);
        function FormlyWrapperFormField() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FormlyWrapperFormField.decorators = [
            { type: core.Component, args: [{
                        selector: 'formly-wrapper-ion-form-field',
                        template: "\n    <ion-item>\n      <ion-label [position]=\"to.labelPosition\">\n        {{ to.label }}\n        <span *ngIf=\"to.required && to.hideRequiredMarker !== true\">*</span>\n      </ion-label>\n      <ng-template #fieldComponent></ng-template>\n    </ion-item>\n    <ion-item lines=\"none\" *ngIf=\"showError\">\n      <ion-label>\n        <ion-text color=\"danger\">\n          <p>\n            <formly-validation-message [field]=\"field\"></formly-validation-message>\n          </p>\n        </ion-text>\n      </ion-label>\n    </ion-item>\n  "
                    }] }
        ];
        FormlyWrapperFormField.propDecorators = {
            fieldComponent: [{ type: core.ViewChild, args: ['fieldComponent', { read: core.ViewContainerRef },] }]
        };
        return FormlyWrapperFormField;
    }(core$1.FieldWrapper));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var IonFormlyAttributes = /** @class */ (function (_super) {
        __extends(IonFormlyAttributes, _super);
        function IonFormlyAttributes() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} element
         * @param {?} value
         * @return {?}
         */
        IonFormlyAttributes.prototype.focusElement = /**
         * @param {?} element
         * @param {?} value
         * @return {?}
         */
            function (element, value) {
                if (!element.setFocus || !value) {
                    return;
                }
                if (!element.getInputElement()) {
                    setTimeout(( /**
                     * @return {?}
                     */function () { return element.setFocus(); }), 300);
                }
                else {
                    element.setFocus();
                }
            };
        IonFormlyAttributes.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line
                        selector: '[ionFormlyAttributes]',
                        host: {
                            '[attr.name]': 'field.name',
                            '[attr.step]': 'to.step',
                            '(keyup)': 'to.keyup && to.keyup(field, $event)',
                            '(keydown)': 'to.keydown && to.keydown(field, $event)',
                            '(click)': 'to.click && to.click(field, $event)',
                            '(keypress)': 'to.keypress && to.keypress(field, $event)',
                            '(ionChange)': 'to.change && to.change(field, $event)',
                            '(ionFocus)': 'onFocus($event)',
                            '(ionBlur)': 'onBlur($event)',
                        },
                    },] }
        ];
        IonFormlyAttributes.propDecorators = {
            field: [{ type: core.Input, args: ['ionFormlyAttributes',] }]
        };
        return IonFormlyAttributes;
    }(core$1.FormlyAttributes));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormlyFormFieldModule = /** @class */ (function () {
        function FormlyFormFieldModule() {
        }
        FormlyFormFieldModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [FormlyWrapperFormField, IonFormlyAttributes],
                        exports: [IonFormlyAttributes],
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            angular.IonicModule,
                            core$1.FormlyModule.forChild({
                                wrappers: [{
                                        name: 'form-field',
                                        component: FormlyWrapperFormField,
                                    }],
                            }),
                        ],
                    },] }
        ];
        return FormlyFormFieldModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.FormlyFormFieldModule = FormlyFormFieldModule;
    exports.ɵa = FormlyWrapperFormField;
    exports.ɵb = IonFormlyAttributes;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-formly-ionic-form-field.umd.js.map